//
// Copyright (c) 2011 NEC Corporation. All rights reserved.
//

#pragma once

#include "stdio.h"
#include <tchar.h>
#include <yvals.h>
#include <psapi.h>

#define MYDEBUG 1
#ifdef MYDEBUG
extern volatile int iPrintDebugState;	/* -2:busy, 0:never print, 1:only js print, 2: all print */
static void PrintDebugMessage(LPCTSTR funcname, int line, LPCTSTR str, ...) {
    TCHAR cbuf[1024];
    TCHAR fmt[256];
	SYSTEMTIME ltm;
	int iTmpEnableDebugPrint;
	if (iPrintDebugState < 0) return;
	iTmpEnableDebugPrint = iPrintDebugState;
	iPrintDebugState = -2;

	GetLocalTime(&ltm);
	MEMORYSTATUS memstate;
	GlobalMemoryStatus(&memstate);
	DWORD dwMemSize = 0;
	PROCESS_MEMORY_COUNTERS pmc = { 0 };
    DWORD dwProcessID = GetCurrentProcessId();
    HANDLE hProcess;
	if ( (hProcess = OpenProcess(PROCESS_QUERY_INFORMATION,FALSE,dwProcessID)) != NULL ){
        if ( GetProcessMemoryInfo(hProcess,&pmc,sizeof(pmc)) ){
            dwMemSize = pmc.WorkingSetSize;
		}
		CloseHandle( hProcess );
	}
	va_list arg;
    va_start(arg, str);
    int iLen = _stprintf_s(fmt, 255, _T("%02d:%02d:%02d, MEM = %d, MEM(WorkingSet)=%d, %s(%d):%s"), ltm.wHour, ltm.wMinute, ltm.wSecond, memstate.dwMemoryLoad, dwMemSize, funcname, line, str);
	if (iLen < 0) iLen = 0;
	fmt[iLen] = 0;
    int iLen2 = _vstprintf_s(cbuf, 1023, fmt, arg);
	if (iLen2 < 0) iLen2 = 0;
	cbuf[iLen2] = 0;
    OutputDebugString( cbuf );
    va_end(arg);
	iPrintDebugState = iTmpEnableDebugPrint;
}

#define MYDEBUGMSG( str, ... )  {\
	if (iPrintDebugState == -2) \
		OutputDebugStringA("#### Another Thread is Blokking DebugPrint !! ####\n"); \
	else \
		if (iPrintDebugState == 2) PrintDebugMessage(__FUNCTIONW__, __LINE__, str, __VA_ARGS__); }

#else

#define MYDEBUGMSG(str, ... ) // 

#endif
