/*
 * Copyright (C) 2009 Apple Inc. All Rights Reserved.
 * Copyright (C) 2009 Brent Fulgham. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#include "stdafx.h"
#include "PrintWebUIDelegatePrivate2.h"

#include <WebKit/WebKitCOMAPI.h>
#include <commctrl.h>
#include <commdlg.h>
#include <objbase.h>
#include <shlwapi.h>
#include <wininet.h>

#define WM_ERR_UIDelegatePrivate2 (WM_USER+3)

static const int MARGIN = 20;
extern HWND hMainWnd;

HRESULT PrintWebUIDelegatePrivate2::QueryInterface(REFIID riid, void** ppvObject)
{
    *ppvObject = 0;
    if (IsEqualIID(riid, IID_IUnknown))
        *ppvObject = static_cast<IWebUIDelegatePrivate2*>(this);
    else if (IsEqualIID(riid, IID_IWebUIDelegatePrivate2))
        *ppvObject = static_cast<IWebUIDelegatePrivate2*>(this);
    else
        return E_NOINTERFACE;

    AddRef();
    return S_OK;
}

ULONG PrintWebUIDelegatePrivate2::AddRef(void)
{
    return ++m_refCount;
}

ULONG PrintWebUIDelegatePrivate2::Release(void)
{
    ULONG newRef = --m_refCount;
    if (!newRef)
        delete this;

    return newRef;
}

HRESULT webViewScrolled( IWebView* sender)
{
	return E_NOTIMPL;
}
HRESULT webViewAddMessageToConsole( IWebView* sender,  BSTR message,  int lineNumber,  BSTR url,  BOOL isError)
{
	return E_NOTIMPL;
}
HRESULT webViewShouldInterruptJavaScript( IWebView* sender,  BOOL* result)
{
	return E_NOTIMPL;
}
HRESULT webViewReceivedFocus( IWebView* sender)
{
	return E_NOTIMPL;
}
HRESULT webViewLostFocus( IWebView* sender,  OLE_HANDLE loseFocusToHWnd)
{
	return E_NOTIMPL;
}
HRESULT doDragDrop( IWebView* sender,  IDataObject* dataObject,  IDropSource* dropSource,  DWORD okEffect,  DWORD* performedEffect)
{
	return E_NOTIMPL;
}
HRESULT webViewGetDlgCode( IWebView* sender,  UINT keyCode,  LONG_PTR* code)
{
	return E_NOTIMPL;
}
HRESULT webViewPainted( IWebView* sender)
{
	return E_NOTIMPL;
}
HRESULT exceededDatabaseQuota( IWebView* sender,  IWebFrame* frame,  IWebSecurityOrigin* origin,  BSTR databaseIdentifier)
{
	return E_NOTIMPL;
}
HRESULT embeddedViewWithArguments( IWebView* sender,  IWebFrame* frame,  IPropertyBag* arguments,  IWebEmbeddedView** view)
{
	return E_NOTIMPL;
}
HRESULT unused3()
{
	return E_NOTIMPL;
}
HRESULT webViewClosing( IWebView* sender)
{
	return E_NOTIMPL;
}
HRESULT webViewSetCursor( IWebView* sender,  OLE_HANDLE cursor)
{
	return E_NOTIMPL;
}
HRESULT webViewDidInvalidate( IWebView* sender)
{
	return E_NOTIMPL;
}
